Skip to main content

Upgrading to v4

Before upgrading to v4, consider the below breaking changes.
As for any dependency upgrade, it’s very important to test this upgrade in your testing environments. Not doing so could result in your admin panel being unusable.
To upgrade to v4, simply run:
npm install forest-express-sequelize@4.0.2
In case of a regression introduced in Production after the upgrade, a rollback to your previous agent version 3 is the fastest way to restore your admin panel.

Breaking changes

New JWT authentication token

The information format of the session token have changed in v4.
You could be impacted if you use the user session in Smart Action controllers or Smart Routes
Calling req.user in v3
{
  "id": "172",
  "type": "users",
  "data": {
    "email": "angelicabengtsson@doha2019.com",
    "first_name": "Angelica",
    "last_name": "Bengtsson",
    "teams": ["Pole Vault"],
  },
  "relationships": {
    "renderings": {
      "data": [{
        "type": "renderings",
        "id": "4998",
      }],
    },
  },
  "iat": 1569913709,
  "exp": 1571123309
}
Calling req.user in v4
{
  "id": "172",
  "email": "angelicabengtsson@doha2019.com",
  "firstName": "Angelica",
  "lastName": "Bengtsson",
  "team": "Pole Vault",
  "renderingId": "4998",
  "iat": 1569913709,
  "exp": 1571123309
}
Consequently, the user information is now accessible as described below:
Propertyv3v4
emailreq.user.data.emailreq.user.email
first namereq.user.data.first_namereq.user.firstName
last namereq.user.data.last_namereq.user.lastName
teamreq.user.data.teams[0]req.user.team
rendering idreq.user.relationships.renderings.data[0].idreq.user.renderingId

New filters query parameters format

The query parameters sent for filtering purposes have changed in v4.
You could be impacted if you have custom filter implementations.
Below are a few example of the new filter conditions format you can access usingreq.params.filters:
{
  "field": "planLimitationReachedAt",
  "operator": "previous_year_to_date",
  "value": null
}
{
  "aggregator": "and",
  "conditions": [{
    "field": "planLimitationReachedAt",
    "operator": "previous_year_to_date",
    "value": null
  }, {
    "field": "planLimitationStatus",
    "operator": "equal",
    "value": "warning"
  }]
}

MongoDB

This section is dedicated to breaking changes on projects using MongoDB connections.

MongoDB version support

The minimal version supported by the agent v4 is MongoDB v3.2 (December 2015).
If your project uses an older MongoDB version, you should not upgrade to v4.
The way the agent implements the resources filtering changed and this new implementation uses features that does not exist in MongoDB versions older than 3.2.

Smart Field search implementation

The Smart Field search implementation has changed:
  • The function signature now has only one search parameter.
  • The expected value to be returned is a hash of the conditions (instead of the query object).
See the following implementation migration example:
 search(query, search) {
  let names = search.split(' ');

  query._conditions.$or.push({
    firstname: names[0],
    lastname: names[1]
  });

  return query;
}
search(search) {
  let names = search.split(' ');

  return {
    firstname: names[0],
    lastname: names[1]
  };
}

Condition operator changes

For consistency reasons, contains, starts with and ends with operators are now case sensitive.

Smart relationships reference syntax

If you had a reference property in a Smart relationship you implemented, the syntax has changed:
reference: 'Address';
reference: 'Address._id';

Important Notice

Agent logout

A consequence of the new session token format is:
Once an agent v4 deployed, all users of your project will be automatically logged out and be forced to re-authenticate to generate a newly formatted token. ​

Changelogs

This release note covers only the major changes. To learn more, please refer to the changelogs in our different repositories: